OpenTTD Source: src/textbuf_gui.h File Reference

OpenTTD Source 14.0-RC3

Typedefs | Enumerations | Functions | Variables
textbuf_gui.h File Reference
`#include "window_type.h"`
`#include "string_type.h"`
`#include "strings_type.h"`

Go to the source code of this file.

## Typedefs
typedef void | QueryCallbackProc(Window *, bool)
| Callback procedure for the ShowQuery method.

## Enumerations
enum | QueryStringFlags { QSF_NONE = 0, QSF_ACCEPT_UNCHANGED = 0x01, QSF_ENABLE_DEFAULT = 0x02, QSF_LEN_IN_CHARS = 0x04, QSF_PASSWORD = 0x08 }
| Flags used in ShowQueryString() call. More...

## Functions
void | ShowQueryString (StringID str, StringID caption, uint max_len, Window *parent, CharSetFilter afilter, QueryStringFlags flags)
| Show a query popup window with a textbox in it. More...
void | ShowQuery (StringID caption, StringID message, Window *w, QueryCallbackProc *callback, bool focus=false)
| Show a confirmation window with standard 'yes' and 'no' buttons The window is aligned to the centre of its parent. More...

## Variables
static const uint | OSK_KEYBOARD_ENTRIES = 50
| The number of 'characters' on the on-screen keyboard.
std::string | _keyboard_opt [2]
| The number of characters has to be OSK_KEYBOARD_ENTRIES. More...

## Detailed Description

Stuff related to the text buffer GUI.

Definition in file textbuf_gui.h.

## Enumeration Type Documentation

## ◆ QueryStringFlags

enum QueryStringFlags

Flags used in ShowQueryString() call.

Enumerator
QSF_ACCEPT_UNCHANGED | return success even when the text didn't change
QSF_ENABLE_DEFAULT | enable the 'Default' button ("\0" is returned)
QSF_LEN_IN_CHARS | the length of the string is counted in characters
QSF_PASSWORD | password entry box, show warning about password security

Definition at line 18 of file textbuf_gui.h.

## Function Documentation

## ◆ ShowQuery()

void ShowQuery | ( | StringID | caption,
|  | StringID | message,
|  | Window * | parent,
|  | QueryCallbackProc * | callback,
|  | bool | focus
| ) |  |

Show a confirmation window with standard 'yes' and 'no' buttons The window is aligned to the centre of its parent.

Parameters

  caption | string shown as window caption
  message | string that will be shown for the window
  parent | pointer to parent window, if this pointer is nullptr the parent becomes the main window WC_MAIN_WINDOW
  callback | callback function pointer to set in the window descriptor
  focus | whether the window should be focussed (by default false)

Definition at line 1231 of file misc_gui.cpp.

References GetMainWindow(), Window::parent, QueryWindow::proc, WC_CONFIRM_POPUP_QUERY, and Window::window_class.

Referenced by CmdPause(), MakeScreenshotWithConfirm(), and SaveLoadWindow::OnTimeout().

## ◆ ShowQueryString()

void ShowQueryString | ( | StringID | str,
|  | StringID | caption,
|  | uint | maxsize,
|  | Window * | parent,
|  | CharSetFilter | afilter,
|  | QueryStringFlags | flags
| ) |  |

Show a query popup window with a textbox in it.

Parameters

  str | StringID for the text shown in the textbox
  caption | StringID of text shown in caption of querywindow
  maxsize | maximum size in bytes or characters (including terminating '\0') depending on flags
  parent | pointer to a Window that will handle the events (ok/cancel) of this window.
  afilter | filters out unwanted character input
  flags | various flags,

See also
  QueryStringFlags

Definition at line 1087 of file misc_gui.cpp.

References CloseWindowByClass(), MAX_CHAR_LENGTH, QSF_LEN_IN_CHARS, and WC_QUERY_STRING.

Referenced by NetworkClientListWindow::OnClickCompanyJoin(), and ToolbarScenDatePanel().

## Variable Documentation

## ◆ _keyboard_opt

std::string _keyboard_opt[2]

The number of characters has to be OSK_KEYBOARD_ENTRIES.

However, these have to be UTF-8 encoded, which means up to 4 bytes per character.

Definition at line 27 of file osk_gui.cpp.

Referenced by GetKeyboardLayout().